<template>
    <div class="s">
        <v-card color="indigo lighten-1" class="mx-auto textcont" dark>
            <v-card-title class="headline mx-auto">增删或更改文件</v-card-title>
            <v-text-field
                outlined
                dense
                class="mx-4"
                label="项目名称"
                color="primary lighten-2"
                clearable
                v-model.trim="projectName"
                @keyup.enter="create_project"
            ></v-text-field>
            <v-text-field
                outlined
                dense
                class="mx-4"
                label="文件名称（或路径）"
                color="primary lighten-2"
                clearable
                v-model.trim="fileName"
                @keyup.enter="create_project"
            ></v-text-field>
            <v-textarea
                outlined
                dense
                class="mx-4"
                label="文件内容"
                color="primary lighten-2"
                clearable
                :error-messages="errorMessage"
                :error="falsee"
                :success-messages="successMessage"
                :success="falsee"
                v-model="fileContent"
                @keyup.enter="create_project"
            ></v-textarea>
            <div class="rightwrap">
                <v-btn color="red lighten-2" class="mr-2 mb-2" @click="create_project">添加</v-btn>
                <v-btn color="red lighten-1" class="mr-2 mb-2" @click="delete_project">删除</v-btn>
            </div>
        </v-card>
    </div>
</template>

<script>
export default {
    name: "addFile",
    data: () => ({
        projectName: "",
        fileName: "",
        fileContent: "",
        falsee: false,
        errorMessage: "",
        successMessage: "",
        user: "",
    }),
    components: {},
    methods: {
        create_project() {
            if (!this.projectName.length || !this.fileName.length) {
                this.login_alert("项目名称及文件路径不得为空！");
                return;
            }

            if (this.projectName.length > 20) {
                this.login_alert("项目名称不能超过20个字符！");
                return;
            }

            if (this.fileName.length > 30) {
                this.login_alert("文件名不能超过30个字符！");
                return;
            }

            this.$axios({
                method: "post",
                url: `/projectfile`,
                data: {
                    operation: "WriteFile",
                    projectName: this.projectName,
                    path: this.fileName,
                    content: this.fileContent,
                },
            }).then(res => {
                console.log(res);
                if (res.status === 200) {
                    const data = res.data;
                    if (data.status === "OK") {
                        this.messagee("更新成功！");
                    } else if (data.status === "ERROR") {
                        this.login_alert("更新失败！");
                    } else if (data.status === "Not_Exist") {
                        this.login_alert("项目不存在！");
                    } else {
                        this.login_alert("出错了！");
                    }
                } else {
                    this.login_alert("连接失败。\n请检查您的网络状态。");
                }
            });
        },
        delete_project() {
            if (!this.projectName.length || !this.fileName.length) {
                this.login_alert("项目名称及文件路径不得为空！");
                return;
            }

            if (this.projectName.length > 20) {
                this.login_alert("项目名称不能超过20个字符！");
                return;
            }

            if (this.fileName.length > 30) {
                this.login_alert("文件名不能超过30个字符！");
                return;
            }

            this.$axios({
                method: "post",
                url: `/projectfile`,
                data: {
                    operation: "DeleteFile",
                    projectName: this.projectName,
                    path: this.fileName,
                },
            }).then(res => {
                if (res.status === 200) {
                    const data = res.data;
                    if (data.status === "OK") {
                        this.messagee("删除成功！");
                    } else if (data.status === "ERROR") {
                        this.login_alert("删除失败！");
                    } else if (data.status === "Not_Exist") {
                        this.login_alert("项目不存在！");
                    } else {
                        this.login_alert("出错了！");
                    }
                } else {
                    this.login_alert("连接失败。\n请检查您的网络状态。");
                }
            });
        },
        login_alert(message) {
            this.errorMessage = "" + message;
        },
        messagee(message) {
            this.errorMessage = "";
            this.successMessage = "" + message;
        },
    },
    mounted() {
        this.user = this.$store.getters.userName;
    },
    computed: {},
};
</script>

<style scoped>
.s {
    margin-top: 15vh;
}
.rightwrap {
    display: flex;
    justify-content: flex-end;
}
</style>
